/* 
 * agr.h - some agrsm core structures
 */

#include <linux/workqueue.h>

typedef struct agr_instance_info agr_instance_info_t;

struct agr_instance_info {
	char *hierarchy_name;
	char *name;

	unsigned g_idx;		/* device index */
	unsigned num;		/* 1 or 18 (instances) */
	unsigned node;		/* nodes for single dev (multiport?) */
	unsigned all_idx;	/* all nodes */

	unsigned codec_type;

	struct agr_resources {
		u32 space1[(0x40 - 0x1c) / sizeof (u32)];

		unsigned io;		/* val 1 for PCI, 2 for AMR */
		unsigned res0;
		unsigned res1;
		u32 space2[(0x54 - 0x4c) / sizeof (u32)];
		unsigned cd;		/* word, set to 1 */
		unsigned irq;
	} res;
	u32 space3[(0xa0 - 0x5c) / sizeof (u32)];
	u32 spec2;
};

struct agr_info {
	int count;
	agr_instance_info_t slot[0x20];
};

typedef struct agr_info agr_info_t, *pagr_info_t;

struct agr_info agrInfos;

struct agr_hardware {
	u32 space1[0x18 / sizeof (u32)];
	union {
		struct work_struct work;
		u32 space2[0x30 / sizeof (u32)]; /* pre-2.6.20 work_struct */
	};
	u32 padd[0];
};

typedef struct agr_hardware agr_hardware_t;
